User visible changes in the firmware version 3.5.0 since version 3.4.x.

                             Highlights.

1. Support for second Bluetooth connection has been implemented for
   Triumph and GISmore devices.

2. NTRIP Server Versions 1.0 and 2.0 support implemented.

3. HTTP server support implemented.

4. The automatic change of the solution mode in the case
   when the current one is impossible had become more correct.

5. Code DGPS mode with using of RTCM3.x and CMR messages
   has been implemented.

6. Compensation for GLONASS inter-channel biases has been implemented.
   Currently real biases for Trimble and Leica receivers are supported.

7. Simultaneous output of RTCM3 messages to multiple ports has
   been fixed.

8. Added measurement of delay in each RF band (using build-in calibrator).
   This is available only for the newest boards/receivers with relevant
   hardware support. New messages and parameters are added. Description
   of old messages and parameters was revised.

9. Internal Glonass representation changed to support extended satellite
   numbers. Thus, Glonass-M sv (which has prn#26 in ephemeris), shows
   this number in NN, NS, and other appropriate messages.

10. QUATTRO: fixed 'pSigma' field of [PG] and [PV] messages being 0
    when RTK position was computed.

11. New parameters were added to UHF and FH drivers that show number
    of sent bytes and frames.


                      More Detailed Description
                (refer to GREIS for even more details)


                             1. Messages.

Hardware Calibrator Messages

Messages described in this section contain measurements obtained by the
Hardware Calibrator (refer to “Hardware Calibrator” on page 89).

[gC], [g1], [g2], [g3]: GLONASS Phase and Code Delays

struct GloDelay {9*nFcn+1} {
  i1 fcn[nFcn]; // GLONASS FCN[-7…6]
  f4 phase[nFcn]; // Phase Delay, [cycles]
  f4 range[nFcn]; // Range Delay, [seconds]
  u1 cs; // Checksum
};

The [gC], [g1], [g2], and [g3] messages contain CA/L1, P/L1, P/L2, and CA/L2 GLONASS
phase and code delays, respectively.

[gR]: Calibrator-calculated code delays of receiver RF bands

struct BandDelay {6} {
  i1 bandName;   // 0-gps1, 1-gps2, 2-gps5, 3-glo1, 4-glo2, 5-glo3
  i1 signalName; // 0-ca, 1-p
  f4 delay;      // Code delay [seconds]
};

struct CalBandsDelay {6*nBands+1} {
  BandDelay d[n]; // n may vary depending on receiver used and calibrator data readiness
  u1 cs; // Checksum
};

.

                             2. Parameters.

2.0 New Bluetooth port name.

/dev/blt/b port name was added.

2.1 New Bluetooth parameters.

Remote Bluetooth Device Address

Name:            /par/dev/blt/X/chan/addr X=[a...b]
Access:          rw
Type:            string[0..12]
Default:         "000000000000"
Description:     Address of remote Bluetooth device which can be connected to this port.
                 If address is "000000000000" then any Bluetooth device can be connected
                 to this port.

Current Remote Bluetooth Device Address

Name:            /par/dev/blt/X/chan/curaddr X=[a...b]
Access:          r
Type:            string[0..12]
Default:         "unknown"
Description:     Address of remote Bluetooth device which connected to this port.

Current Remote Bluetooth Device RSSI

Name:            /par/dev/blt/X/chan/rssi X=[a...b]
Access:          r
Type:            string[0..15]
Default:         "unknown"
Description:     RSSI value of Bluetooth connection for this port,
                 measured in dB, relative to Golden Device Power
                 Range.

2.2 TCP Client parameters.

2.2.1 Modification: TCP Client connection mode, /par/net/tcpcl/mode
a). New value: "ntrips" - this parameter turns on of NTRIP Server mode;

2.2.2 New NTRIP Server parameters

Name:           /par/net/tcpcl/ntrips/addr
Access:         rw
Type:           string
Values:         (any valid IP address)
Default:        0.0.0.0
Description:    IP Address of NTRIP Caster

Name:           /par/net/tcpcl/ntrips/name
Access:         rw
Type:           string [0...64]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Host Name of NTRIP Caster

Name:           /par/net/tcpcl/ntrips/port
Access:         rw
Type:           integer
Values:         [0...65535]
Default:        0
Desctiption:    IP Port of NTRIP Caster

Name:           /par/net/tcpcl/ntrips/mountpt
Access:         rw
Type:           string [0...15]
Values:         (arbitrary string)
Default:        (empty string)
Description:    NTRIP Mount Point. This parameter specifies the mount point of
                the NTRIP Caster to get data from.

Name:           /par/net/tcpcl/ntrips/user
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    NTRIP User Name. This parameter specifies user ID for the protected
                space of the requested mount point. Only basic authentication scheme
                is supported. If empty, no user or password values will be sent to
                the NTRIP caster.

Name:           /par/net/tcpcl/ntrips/passwd
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    NTRIP Password. This parameter specifies the password for the
                protected space of the requested mount point. Only basic
                authentication scheme is supported.

Name:           /par/net/tcpcl/ntrips/host
Access:         rw
Type:           string [0...64]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Host Name. This parameter specifies the host name of the request. It is
                required for virtual hosts (multiple different instances of an NTRIP Caster
                at one server with same port). Informational on receiving side, but required
                for virtual casters.

Name:           /par/net/tcpcl/ntrips/ver
Access:         rw
Type:           integer
Values:         [1...2]
Default:        1
Description:    NTRIP Protocol Version.

Name:           /par/net/tcpcl/ntrips/table
Access:         r
Type:           list { id, format, formatd, carrier, nav, net, country, lat, lon, nmea, sol, gen, compr, auth, fee, bitrate, misc }
Description:    The list of Source-Table parameters.

Name:           /par/net/tcpcl/ntrips/table/id
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Source identifier, e.g. name of city next to source location.

Name:           /par/net/tcpcl/ntrips/table/format
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Data format RTCM, RAW, etc.

Name:           /par/net/tcpcl/ntrips/table/formatd
Access:         rw
Type:           string [0...64]
Values:         (arbitrary string)
Default:        (empty string)
Description:    E.g. RTCM message types or RAW data format etc., update periods
                in parenthesis in seconds.

Name:           /par/net/tcpcl/ntrips/table/carrier
Access:         rw
Type:           integer
Values:         [0...2]
Default:        0
Description:    Data stream contains carrier phase information:
                0=No (e.g. for DGPS); 1=Yes, L1 (e.g. for RTK); 2=Yes, L1&L2 (e.g. for RTK);

Name:           /par/net/tcpcl/ntrips/table/nav
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Navigation system(s).

Name:           /par/net/tcpcl/ntrips/table/net
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Network

Name:           /par/net/tcpcl/ntrips/table/country
Access:         rw
Type:           string [0...3]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Three character country code in ISO 3166.

Name:           /par/net/tcpcl/ntrips/table/lat
Access:         rw
Type:           string [0...16]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Position, latitude, north (approximate position in case of nmea=1).

Name:           /par/net/tcpcl/ntrips/table/lon
Access:         rw
Type:           string [0...16]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Position, longitude, east (approximate position in case of nmea=1).

Name:           /par/net/tcpcl/ntrips/table/nmea
Access:         rw
Type:           integer
Values:         [0...1]
Default:        0
Description:    Necessity for Client to send NMEA message with approximate
                position to Caster: 0=Client must not send NMEA message with
                approximate position to Caster; 1=Client must send NMEA GGA
                message with approximate position to Caster;

Name:           /par/net/tcpcl/ntrips/table/sol
Access:         rw
Type:           integer
Values:         [0...1]
Default:        0
Description:    Stream generated from single reference station or from networked
                reference stations: 0=Single base; 1=Network;

Name:           /par/net/tcpcl/ntrips/table/gen
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Hard or software generating data stream.

Name:           /par/net/tcpcl/ntrips/table/compr
Access:         rw
Type:           string [0...32]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Compression/Encryption algorithm applied.

Name:           /par/net/tcpcl/ntrips/table/auth
Access:         rw
Type:           enumerated
Values:         N,B,D
Default:        N
Description:    Access protection for this particular data stream:
                N=None; B=Basic; D=Digest;

Name:           /par/net/tcpcl/ntrips/table/fee
Access:         rw
Type:           enumerated
Values:         N,Y
Default:        N
Description:    User fee for receiving this particular data stream:
                N=No user fee; Y=Usage is charged;

Name:           /par/net/tcpcl/ntrips/table/bitrate
Access:         rw
Type:           integer
Values:         [0...65535]
Default:        0
Description:    Bit rate of data stream, bits per second.

Name:           /par/net/tcpcl/ntrips/table/misc
Access:         rw
Type:           string [0...64]
Values:         (arbitrary string)
Default:        (empty string)
Description:    Miscellaneous information, last data field in record.

2.3 HTTP Server Parameters.

HTTP Connection Timeout.

     Name:    /par/net/http/timeout
     Access:  rw
     Type:    integer [seconds]
     Values:  [1...0x7FFFFFFF]
     Default: 10

The period of HTTP connection inactivity after which corresponding
socket will be closed.

HTTP Server TLS/SSL Mode.

     Name:    /par/net/http/tls
     Access:  rw
     Type:    boolean
     Values:  on,off
     Default: off

off – only unencrypted HTTP connections will be allowed by HTTP server.

on – only secure TLS/SSL connections will be allowed by HTTP server.

HTTP Port.

     Name:    /par/net/http/port
     Access:  rw
     Type:    integer
     Values:  [1...65535]
     Default: 80

IP port receiver is listening on for incoming HTTP connections.

2.4 New parameter for using DGPS mode with RTCM3 and CMR RTK data.

Name:           /par/pos/cd/src/rtkdata
Access:         rw
Type:           boolean
Default:        off
Desctiption:    When this parameter is turned on then DGPS correction will be
                generated from RTCM3 and CMR RTK data.

2.5 New parameters for compensation of GLONASS inter-channel biases.

Name:           /par/calib/soft/mode
Access:         rw
Type:           enum
Values:         got,fix
Default:        got

This parameter specifies how to utilize the pre-estimated GLONASS
inter-channel biases for reference station.

  got    - utilize predefined biases using brand of reference station
           received from the reference station.
  fix    - utilize the predefined biases using the brand of reference
           station specified by the user in '/par/calib/soft/brand/fix'
           parameter.

Name:           /par/calib/soft/brand/cur
Access:         r
Type:           enum
Values:         unknown,javad,ashtech,topcon,trimble,leica,septentrio
Default:        unknown

This parameter specifies brand of the reference station currently being
used by RTK. 'unknown' means biases are all 0.

Name:           /par/calib/soft/brand/got
Access:         r
Type:           enum
Values:         unknown,javad,ashtech,topcon,trimble,leica,septentrio
Default:        unknown

This parameter specifies brand of the base receiver got from the
reference station. 'unknown' means biases are all 0.

Name:           /par/calib/soft/brand/fix
Access:         rw
Type:           enum
Values:         unknown,javad,ashtech,topcon,trimble,leica,septentrio
Default:        unknown

This parameter allows the user to specify fixed brand of the reference
station. 'unknown' means biases are all 0.

2.6 New TriPad Parameter

Name:    /par/button/fine
Access:  rw
Type:    integer [seconds]
Values:  [0...300]
Default: 0

This pseudo-parameter allows to set number of seconds for which
<POS> or <SAT> LED will blink specially to indicate fine position has been
calculated externally for this unit. This special blinking turns off
when <FN> button is pressed.

When printed, this parameter always returns value 0.


2.7. New and revised Hardware calibrator parameters


Hardware Code/Phase calibrator.

Overview.

Hardware calibrator instantly measures phase and code delays introduced by
the receiver RF part for different GLONASS FCNs (let's call them Glonass
inter-channel correction). Also (if relative hardware support is present)
it measures phase and code delays of other RF bands. It could be programmed
to either apply the selected Glonass corrections to the code and/or phase
measurements, or just to store them inside and output them by user request.
Parameters described in this section govern the behavior of the hardware
calibrator.

Note1: Calibration process should be performed only when GNSS antenna is
connected to the receiver, other wise wrong corrections could be computed.

Note2: Despite the fact that calibrator measurements are relative (actually
they are relative to delay, introduced by calibrator hardware, which should
be extremely small and constant), obtained numbers of delays in different RF
bands may be interpreted as absolute and can be used for different purposes
like precise timing, absolute ionosphere delay calculations and so on.
Calibrator tracks any change of RF delay(s), for example in temperature,
which may be interesting also.


Presence of controlled attenuator in calibrator hardware.

Name: /par/calib/hard/atten
Access: r
Type: boolean
Values: y,n
Default: hardware dependent
Only some early designed boards do not have attenuator. If receiver returns 'n',
we do not recommend to use calibrator code measurements for precise applications
- they are rather noisy.


Ability to make measurements on other than Glonass L1 or Glonass L2 bands.

Name: /par/calib/hard/band
Access: r
Type: enum
Values: glo,all
Default: hardware dependent
Only some newly designed boards do have ability to measure delays in all RF
bands. If receiver returns "glo", it make measures only in Glonass L1 and Glonass
L2 bands (if Glonass L2 RF band is present).


Calibrator Mode

Name: /par/calib/hard/mode
Access: rw
Type: enum
Values: off, alt (only for receivers with E5b band), on.
Default: off or alt (dependant on hardware; alt for receivers with E5b band,
off for all other)
off – calibrator is turned off. alt - only delays between L5(E5a) and E5b bands
are calculated. This helps receiver to track E5altBoc signal as best as
possible. Please do not turn calibrator to 'off' if you track Galileo E5altBoc
signal.
on - calibrator is turned on.


Calibrator Measurements Availability

Name: /par/calib/hard/valid
Access: r
Type: boolean
Values: y,n
Default: n
y – all calibrator measurements are available (it means that calibrator has made
at least one full cycle of all required measurements).
n – no measurements are available.


Usage (global flag) of measured Glonass inter-channel corrections.

Name: /par/calib/hard/use
Access: rw
Type: boolean
Values: on,off
Default: off
on – apply GLONASS inter-frequency corrections, provided they are available.
What particular corrections are applied is selected by  /par/calib/hard/apply parameter.
off – do not apply measured corrections. Corrections are still kept in memory and
are available through calibrator parameters and calibrator GREIS messages
(refer to “Hardware Calibrator Messages” on page 359).


Usage of measured Glonass code and phase  C/A / P1 / L2C / P2  inter-channel corrections

Name: /par/calib/hard/apply/M/B
where M is "code" for code corrections or "phase" for phase corrections.
B is "ca" ,"p1", "l2c" or "p2" band
Access: rw
Type: boolean
Values: on,off
Default: on
on – apply selected GLONASS inter-channel correction to measurements
(if global usage parameter /par/calib/hard/use is set to 'on').


Smoothing of measured Glonass code inter-channel corrections

Name: /par/calib/hard/smooth/code
Access: rw
Type: integer
Values: 0,1,2
Default: 0
GLONASS code inter-channel corrections, measured by Calibrator, can be
unsmoothed (0), smoothed using linear polynomial approximation(1),
smoothed using quadrature polynomial approximation(2). We do not recommend to
change this parameter from it's default value because approximation may hide
measurements accuracy.


Smoothing of measured Glonass phase inter-channel corrections

Name: /par/calib/hard/smooth/phase
Access: rw
Type: integer
Values: 1,2,3
Default: 1
GLONASS phase inter-channel corrections, measured by Calibrator, made being free
from constant slope. They can be unsmoothed (1), smoothed using linear
polynomial approximation(2), smoothed using quadrature polynomial
approximation(3). We do not recommend to change this parameter from it's default
value because approximation may hide measurements accuracy.


Input point where Calibrator signal is mixed into the receiver signal.

Name: /par/calib/hard/inp
Access: rw
Type: enumerated
Values: rf, antint, antext
Default: rf
Usually calibrator signal is mixed into the receiver signal at the point where
satellite signal comes to receiver RF board from antenna (rf). For special purposes and
with special hardware it is possible to provide calibrator signal to internal
(antint) or external (antext) antenna via second antenna cable coming from
special receiver socket to special antenna socket. This allows to calibrate
not only receiver's RF band(s), but antenna circuitry also. Suitable for antenna
parameters investigation. Also may be used for precise timing applications:
calibrator will calculate temperature-dependent signal delay for all
receiver/antenna path. Do not change this parameter until you have special hardware.


Measured code delays of RF bands.

Name: /par/calib/hard/delay/B/C
where B is RF band. May be "gps1", "gps2", "gps5", "glo1", "glo2", glo3" (depends on receiver RF bands).
C is signal. May be "ca" or "p".
Access: r
Type: float [meters]
Values: [0 - 500]
Default: 0
Returns 0 if value is not measured yet or if Calibrator hardware does not
support it's calculation.


Measured code and phase Glonass inter-channel corrections

Name: /par/calib/hard/X
where X may be "c1delay", "c1phase","p1delay", "p1phase","c2delay", "c2phase","p2delay", "p2phase".
Access: r
Type: integer [millimeters] for code corrections and [1/10000 of cycle] for phase corrections
Values: [0 - 10000]
Default: 0
Returns 0 if value is not measured yet

2.8 New UHF driver parameters.

Name:           /par/modem/X/uhf/inf/link/tx/cnt/frame
Access:	        r
Type:	        integer
Values:         [0..MAX_UINT]
Default:        0
Description:    Number of transferred frames.

Name:           /par/modem/X/uhf/inf/link/tx/cnt/byte
Access:	        r
Type:	        integer
Values:         [0..MAX_UINT]
Default:	0
Description:    Number of transferred bytes.

2.9 New FH driver parameter.

Name:           /par/modem/X/fh/inf/link/tx/cnt/byte
Access:	        r
Type:	        integer
Values:         [0..MAX_UINT]
Default:        0
Description:    Number of transferred bytes.



                             3. Options.

4.1 TCCL: new bit implemented:

OPTCCL_NTRIPSRV = 0x08

4.2 New option HTTP: 0|1

This option enables HTTP server.


<END>
